"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class AaveHistoricalTransactionsChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


AaveHistoricalTransactionsBlockTypedDict = TypeAliasType(
    "AaveHistoricalTransactionsBlockTypedDict", Union[int, str]
)
r"""The block number you want to get this data at."""


AaveHistoricalTransactionsBlock = TypeAliasType(
    "AaveHistoricalTransactionsBlock", Union[int, str]
)
r"""The block number you want to get this data at."""


class AaveHistoricalTransactionsRequestTypedDict(TypedDict):
    offset: NotRequired[int]
    r"""The offset of the first item to return."""
    limit: NotRequired[int]
    r"""The number of items to return."""
    chain: AaveHistoricalTransactionsChain
    r"""The chain to use."""
    block: NotRequired[AaveHistoricalTransactionsBlockTypedDict]
    r"""The block number you want to get this data at."""
    user_address: str
    r"""The address of the user to get historical transactions for."""


class AaveHistoricalTransactionsRequest(BaseModel):
    offset: Annotated[
        Optional[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = 0
    r"""The offset of the first item to return."""

    limit: Annotated[
        Optional[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = 100
    r"""The number of items to return."""

    chain: Annotated[
        AaveHistoricalTransactionsChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = AaveHistoricalTransactionsChain.ARBITRUM_MAINNET
    r"""The chain to use."""

    block: Annotated[
        Optional[AaveHistoricalTransactionsBlock],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The block number you want to get this data at."""

    user_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B"
    r"""The address of the user to get historical transactions for."""
