"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class AaveUserPositionSummaryChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


AaveUserPositionSummaryBlockTypedDict = TypeAliasType(
    "AaveUserPositionSummaryBlockTypedDict", Union[int, str]
)
r"""The block number you want to get this data at."""


AaveUserPositionSummaryBlock = TypeAliasType(
    "AaveUserPositionSummaryBlock", Union[int, str]
)
r"""The block number you want to get this data at."""


class AaveUserPositionSummaryRequestTypedDict(TypedDict):
    chain: AaveUserPositionSummaryChain
    r"""The chain to use."""
    block: NotRequired[AaveUserPositionSummaryBlockTypedDict]
    r"""The block number you want to get this data at."""
    user: str
    r"""The user to get position summary for."""


class AaveUserPositionSummaryRequest(BaseModel):
    chain: Annotated[
        AaveUserPositionSummaryChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = AaveUserPositionSummaryChain.ARBITRUM_MAINNET
    r"""The chain to use."""

    block: Annotated[
        Optional[AaveUserPositionSummaryBlock],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The block number you want to get this data at."""

    user: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B"
    r"""The user to get position summary for."""
