"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class GenericEnsChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


GenericEnsBlockTypedDict = TypeAliasType("GenericEnsBlockTypedDict", Union[int, str])
r"""The block number you want to get this data at."""


GenericEnsBlock = TypeAliasType("GenericEnsBlock", Union[int, str])
r"""The block number you want to get this data at."""


class GenericEnsRequestTypedDict(TypedDict):
    chain: GenericEnsChain
    r"""The chain to use."""
    block: NotRequired[GenericEnsBlockTypedDict]
    r"""The block number you want to get this data at."""
    ens_name: NotRequired[str]
    r"""The ENS name to resolve."""


class GenericEnsRequest(BaseModel):
    chain: Annotated[
        GenericEnsChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = GenericEnsChain.ETHEREUM_MAINNET
    r"""The chain to use."""

    block: Annotated[
        Optional[GenericEnsBlock],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The block number you want to get this data at."""

    ens_name: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = "vitalik.eth"
    r"""The ENS name to resolve."""
