"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class MorphoMarketChain(str, Enum):
    ETHEREUM_MAINNET = "ethereum:mainnet"
    BASE_MAINNET = "base:mainnet"


MorphoMarketBlockTypedDict = TypeAliasType(
    "MorphoMarketBlockTypedDict", Union[int, str]
)
r"""The block number you want to get this data at."""


MorphoMarketBlock = TypeAliasType("MorphoMarketBlock", Union[int, str])
r"""The block number you want to get this data at."""


class MorphoMarketRequestTypedDict(TypedDict):
    chain: MorphoMarketChain
    block: NotRequired[MorphoMarketBlockTypedDict]
    r"""The block number you want to get this data at."""
    unique_market_key: str
    r"""The key that uniquely identifies the market. This can be found using the 'Get Markets' endpoint."""


class MorphoMarketRequest(BaseModel):
    chain: Annotated[
        MorphoMarketChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = MorphoMarketChain.ETHEREUM_MAINNET

    block: Annotated[
        Optional[MorphoMarketBlock],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The block number you want to get this data at."""

    unique_market_key: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0x83b7ad16905809ea36482f4fbf6cfee9c9f316d128de9a5da1952607d5e4df5e"
    r"""The key that uniquely identifies the market. This can be found using the 'Get Markets' endpoint."""
