"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class PendlePositionChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


PendlePositionBlockTypedDict = TypeAliasType(
    "PendlePositionBlockTypedDict", Union[int, str]
)
r"""The block number you want to get this data at."""


PendlePositionBlock = TypeAliasType("PendlePositionBlock", Union[int, str])
r"""The block number you want to get this data at."""


class PendlePositionRequestTypedDict(TypedDict):
    chain: PendlePositionChain
    r"""The chain to use."""
    block: NotRequired[PendlePositionBlockTypedDict]
    r"""The block number you want to get this data at."""
    user_address: str
    r"""The user address of the desired position."""
    market_address: str
    r"""The market address of the desired position."""


class PendlePositionRequest(BaseModel):
    chain: Annotated[
        PendlePositionChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = PendlePositionChain.ETHEREUM_MAINNET
    r"""The chain to use."""

    block: Annotated[
        Optional[PendlePositionBlock],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The block number you want to get this data at."""

    user_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0xa829B388A3DF7f581cE957a95edbe419dd146d1B"
    r"""The user address of the desired position."""

    market_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0xdace1121e10500e9e29d071f01593fd76b000f08"
    r"""The market address of the desired position."""
